#pragma once

#include <map>

// Base Class
#include "../Filter.h"

namespace armarx::armem::server::ltm::processor::filter
{
    class MemoryFrequencyFilter : public MemoryFilter
    {
    public:
        static const constexpr char* NAME = "MemoryFrequencyFilter";
        static const constexpr char* PARAM_WAITING_TIME = "WaitingTimeInMs";

        MemoryFrequencyFilter() = default;

        virtual bool accept(const armem::wm::Memory& e) override;
        void configure(const nlohmann::json& json) override;

    public:
        int waitingTimeInMs = -1;

    private:
        long timestampLastCommitInMs = 0;
    };

    class SnapshotFrequencyFilter : public SnapshotFilter
    {
    public:
        static const constexpr char* NAME = "SnapshotFrequencyFilter";
        static const constexpr char* PARAM_WAITING_TIME = "WaitingTimeInMs";

        SnapshotFrequencyFilter() = default;

        virtual bool accept(const armem::wm::EntitySnapshot& e) override;
        void configure(const nlohmann::json& json) override;

    public:
        int waitingTimeInMs = -1;

    private:
        std::map<MemoryID, long> timestampLastCommitInMs;
    };
} // namespace armarx::armem::server::ltm::processor::filter
