/*
 * This file is part of ArmarX.
 *
 * Copyright (C) 2012-2016, High Performance Humanoid Technologies (H2T),
 * Karlsruhe Institute of Technology (KIT), all rights reserved.
 *
 * ArmarX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * ArmarX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * @author     Fabian Peller-Konrad (fabian dot peller-konrad at kit dot edu)
 * @copyright  http://www.gnu.org/licenses/gpl-2.0.txt
 *             GNU General Public License
 */

#pragma once

#include <RobotAPI/libraries/aron/codegeneration/codegenerator/codewriter/cpp/generator/Generator.h>

#include <memory>
#include <string>


namespace armarx::aron::codegenerator::cpp::generator::detail
{
    template<typename TypeT, typename DerivedT>
    class SpecializedGeneratorBase :
        public codegenerator::cpp::Generator
    {
    public:
        SpecializedGeneratorBase(const std::string& instantiatedCppTypename, const std::string& classCppTypename, const std::string& aronDataTypename, const std::string& aronTypeTypename, const TypeT& t) :
            Generator(instantiatedCppTypename, classCppTypename, aronDataTypename, aronTypeTypename),
            type(t)
        {
        }
        virtual ~SpecializedGeneratorBase() = default;

        virtual const type::Variant& getType() const override
        {
            return type;
        }

    protected:
        TypeT type;
    };
}
