#include "ProviderID.h"

#include "SkillID.h"

namespace armarx
{
    namespace skills
    {
        bool
        ProviderID::operator==(const ProviderID& other) const
        {
            return toString() == other.toString();
        }

        bool
        ProviderID::operator!=(const ProviderID& other) const
        {
            return not(*this == other);
        }

        bool
        ProviderID::operator<(const ProviderID& other) const
        {
            return toString() < other.toString();
        }

        bool
        ProviderID::operator<=(const ProviderID& other) const
        {
            return toString() <= other.toString();
        }

        ProviderID
        ProviderID::FromIce(const manager::dto::ProviderID& s)
        {
            return ProviderID{.providerName = s.providerName};
        }

        ProviderID
        ProviderID::FromIce(const callback::dto::ProviderID& s)
        {
            return ProviderID{.providerName = s.providerName};
        }

        manager::dto::ProviderID
        ProviderID::toManagerIce() const
        {
            return {providerName};
        }

        callback::dto::ProviderID
        ProviderID::toCallbackIce() const
        {
            return {providerName};
        }

        std::string
        ProviderID::toString() const
        {
            return providerName;
        }
    } // namespace skills

    std::ostream&
    skills::operator<<(std::ostream& os, const ProviderID& id)
    {
        return os << "'" << id.toString() << "'";
    }
} // namespace armarx
